#pragma once
/*****************************************************************//**
 * \file   SatelliteOribtModel.h
 * \brief  ģ
 * 
 * \author 
 * \date   October 2024
 *********************************************************************/
#include "LogInfoCls.h"
#include "BaseConstVariable.h"
#include "SARSatelliteSimulationAbstractCls.h"
#include <vector>
#include <memory>

/// <summary>
/// ʽģ
/// </summary>
class PolyfitSatelliteOribtModel:public AbstractSatelliteOribtModel
{
public:
	PolyfitSatelliteOribtModel();
	~PolyfitSatelliteOribtModel() override;
public:
	QString getSatelliteOribtModelParamsString();

public: // ǹڵ
	virtual SatelliteOribtNode getSatelliteOribtNode(double& timeFromStartTime, bool& antAzAngleFlag) override; // ȡڵ
	virtual ErrorCode getSatelliteOribtNode(double& timeFromStartTime, SatelliteOribtNode& node, bool& antAzAngleFlag) override; // ȡڵ
	virtual ErrorCode getSatelliteAntDirectNormal(SatelliteOribtNode& Rs, Vector3D& Rt, SatelliteAntDirect& antNode); // Ŀ߷ͼеλ
public: // ǹģ͵Ĳοʱڵ
	virtual void setSatelliteOribtStartTime(long double oribtStartTime) override;// ģͲοʱ
	virtual long double  getSatelliteOribtStartTime() override;// ȡģͲοʱ
public: // ز
	virtual void setbeamAngle(double beamAngle, bool RightLook) override;// òλ

public: // ߰ڶز
	virtual void setAzAngleRange(double cycletime, double minAzAngle, double maxAzAngle, double referenceAzAngle, double referenceTimeFromStartTime) override;//λǱ任ѭʱ ;λǱ任Χ ضʱķλǣڼ㷽λǱ仯
	
	virtual double getAzAngleInCurrentTimeFromStartTime(double& currentTime) override;// ȡǰʱ ߰ڶ
	virtual ErrorCode getAzAngleInCurrentTimeFromStartTime(double& currentTime, double& AzAngle);// ȡǰʱ ߰ڶ

public: // ԭʼµϵĵȻ-Z Ϊ ָ
	virtual void setAntnnaAxisX(double X, double Y, double Z) override; // Xָ
	virtual void setAntnnaAxisY(double X, double Y, double Z) override; // Xָ
	virtual void setAntnnaAxisZ(double X, double Y, double Z) override; // Xָ
	
	virtual ErrorCode getAntnnaDirection(SatelliteOribtNode& node) override; // ȡָ
	virtual ErrorCode getZeroDopplerAntDirect(SatelliteOribtNode& node) override;
private: // 
	long double oribtStartTime; // ģͲοʱ
	double beamAngle; // λ
	bool RightLook; // 
	double cycletime; // λǱ任ѭʱ
	double minAzAngle; // λǱ任Χ
	double maxAzAngle; // λǱ任Χ
	double referenceAzAngle; // ضʱķλǣڼ㷽λǱ仯
	double referenceTimeFromStartTime; // ضʱķλǣڼ㷽λǱ仯

	Point3 AntnnaAxisX; // Xָ
	Point3 AntnnaAxisY; // Yָ
	Point3 AntnnaAxisZ; // Zָ


public: // ӽڵ
	void addOribtNode(SatelliteOribtNode node);
	ErrorCode polyFit(int polynum = 3, bool input_timeFromReferenceTime = false);


private: // ڵ
	std::vector<SatelliteOribtNode> oribtNodes;

	std::vector<double> polyfitPx; // ռ
	std::vector<double> polyfitPy;
	std::vector<double> polyfitPz;
	std::vector<double> polyfitVx; // ٶϲ
	std::vector<double> polyfitVy;
	std::vector<double> polyfitVz;

	double Pxchisq; //  X2
	double Pychisq;
	double Pzchisq;
	double Vxchisq;
	double Vychisq;
	double Vzchisq;

public:
	virtual double getPt() override;
	virtual double getGri() override;
	virtual void setPt(double Pt) override;
	virtual void setGri(double gri) override;

	//virtual double getPt();
	//virtual double getGri();
	//virtual void setPt(double Pt);
	//virtual void setGri(double gri);



private:
	double Pt; // ѹ
	double Gri;// ϵͳ

};

std::shared_ptr<AbstractSatelliteOribtModel>   CreataPolyfitSatelliteOribtModel(std::vector<SatelliteOribtNode> &nodes, long double startTime,int polynum=3);







