#pragma once
/*****************************************************************//**
 * \file   TBPImageAlgCls.h
 * \brief  BP㷨
 *
 * ο
 * ״ ϵ
 * 
 * ƽ涨Ϊ ¼ȡƽ棨P94, ״
 * ¼ȡƽ涨Ϊ߷
 * 
 *
 * \author 
 * \date   October 2024
 *********************************************************************/
#define EIGEN_USE_BLAS
#define EIGEN_USE_LAPACK
#define EIGEN_ENABLE_AVX512
#define EIGEN_VECTORIZE_SSE
#define EIGEN_VECTORIZE_SSE2
#define EIGEN_VECTORIZE_SSSE3
#define EIGEN_VECTORIZE_SSE4_1
#define EIGEN_VECTORIZE_SSE4_2
#include "BaseConstVariable.h"

#include "SARSatelliteSimulationAbstractCls.h"
#include "SARSimulationTaskSetting.h"
#include "SatelliteOribtModel.h"
#include "EchoDataFormat.h"
#include "SARSimulationImageL1.h"
#include "LogInfoCls.h"

class TBPImageAlgCls
{
private:
	std::shared_ptr<SARSimulationImageL1Dataset> L1ds;
	std::shared_ptr < EchoL0Dataset> L0ds;
	QString imagePlanePath;
	bool GPURUN;
	QString outRasterXYZPath;
public:

	void setImagePlanePath(QString imagePlanePath);
	QString getImagePlanePath();

	void setEchoL0(std::shared_ptr < EchoL0Dataset> L0ds);
	void setImageL1(std::shared_ptr<SARSimulationImageL1Dataset> L1ds);

	std::shared_ptr < EchoL0Dataset> getEchoL1();
	std::shared_ptr<SARSimulationImageL1Dataset> getImageL0();

public:
	ErrorCode Process(long num_thread);
	void setGPU(bool flag);
	bool getGPU( );
private:
	//ErrorCode ProcessCPU(long num_thread);
	ErrorCode ProcessGPU();


};


void CreatePixelXYZ(std::shared_ptr<EchoL0Dataset> echoL0ds,QString outPixelXYZPath);


void TBPImageProcess(QString echofile,QString outImageFolder,QString imagePlanePath,long num_thread);
void TBPImageGPUAlg(std::shared_ptr<float> antPx, std::shared_ptr<float> antPy, std::shared_ptr<float> antPz,  
	std::shared_ptr<float> img_x, std::shared_ptr<float> img_y, std::shared_ptr<float> img_z,  
	std::shared_ptr<std::complex<double>> echoArr, 
	std::shared_ptr<std::complex<double>> img_arr,
	float freq, float fs, float Rnear, float Rfar,
	long rowcount, long colcount,
	long prfcount,long freqcount,
	long startPRFId,long startRowID
	);
